REM
REM This function checks whether a given resolution is
REM supported or not by your video adapter.
REM
REM Returns 1 if the resolution is available, zero otherwise.
REM
REM Copyright (C) Mateusz Viste 2010
REM

FUNCTION ChkVideoMode(BYREF xRes AS UINTEGER, BYREF yRes AS UINTEGER, BYREF ColorDept AS UBYTE) AS BYTE
  DIM InfoData AS INTEGER
  InfoData = SCREENLIST(ColorDept)
  DO
    IF (HIWORD(InfoData) = xRes) AND (LOWORD(InfoData) = yRes) THEN EXIT DO
    InfoData = SCREENLIST
  LOOP UNTIL (InfoData = 0)
  IF (InfoData > 0) THEN
      RETURN 1
    ELSE
      RETURN 0
  END IF
END FUNCTION
