' HTTP GET by D.J.Peters (Joshy)
#include "net.bi"
#define crlf chr(13) & chr(10)

dim as FDSOCKET    hClient,hServer
dim as SOCKADDR_in ServerAddr,Iam
dim As HOSTENT ptr lpResolver
dim as string      msg
dim as integer     ret
dim as uinteger    ip
dim as string      servername="alice-dsl.net"

? "create socked"
hClient=NetSocket(AF_INET,SOCK_STREAM)
if hClient<0 then
  ? "error: create socket!"
  sleep:end 2
end if

'get ip from server
? "get ip from server " & servername
lpResolver=NetGetHostByName (servername)
if lpResolver=0 then
  ? "error: NetGetHostByName!"
  beep:sleep:end 3
else
  ip=*lpResolver->h_addr_ip_list[0] 'server ip
  ? "IP=" & (ip and &H000000FF) shr  0 & "." _
          & (ip and &H0000FF00) shr  8 & "." _
          & (ip and &H00FF0000) shr 16 & "." _
          & (ip and &HFF000000) shr 24
end if

with ServerAddr
  .sin_family = AF_INET    ' protocol
  .sin_port   = htons(80)  ' port 80   in network byte order
  .sin_addr   = ip         ' server ip in network byte order
end with

? "connect to server"
ret=NetConnect(hClient,@ServerAddr)
if ret<0 then
  ? "error: can't connect to server!"
  beep:sleep:end 4
end if

dim as string method,host,accept
method    = "GET /d.j.peters/test.txt HTTP/1.1"  & crlf
host      = "Host: www.alice-dsl.net"            & crlf
accept    = "Accept: text/html;text/plain"       & crlf
msg       = method & host & accept               & crlf

ret=NetSendString(hClient,msg)
if ret<=0 then
  ? "error: send string!"
  NetClose hClient
  beep:sleep:end 6
else 
  ? ret & " chars sended"
end if
print "get file test.txt please wait ..."
ret=NetReceiveString(hClient,msg)
NetClose hClient

if ret<0 then
  ? "error: get file/site!"
else
  ?
  ? "answer from server"
  ? "------------------"
  beep
  ret =instr(msg,crlf & crlf) 'search for header terminator
  ret+=3 ' jump over "crlf"
  ' cut the HTTP header from message 
  msg=right(msg,len(msg)-ret) 
  ? msg
  'optional save the answer
  'open exepath + "\answer.txt" for output as #1
  ' print #1,msg
  'close #1
end if

sleep
end

