' sendmail.bas
' with base64 authentication D.j.Peters
#include "net.bi"
const as string CRLF = Chr(13) & Chr(10)

function E0(v1 as integer) as integer
  return v1 shr 2
end function
function E1(v1 as integer, _
            v2 as integer) as integer
  return ((v1 and 3) shl 4) + (v2 shr 4)
end function
function E2(v2 as integer, _
            v3 as integer) as integer
  return ((v2 and &H0F) shl 2) + (v3 shr 6)
end function
function E3(v3 as integer) as integer
  return (v3 and &H3F)
end function

Function Encode(S As String) As String
  dim as string C = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" & _
                    "abcdefghijklmnopqrstuvwxyz" & _
                    "0123456789+/"
  dim as Integer j,k,l=len(S)
  dim as string  t
  if l=0 then return t

  t=string(((l+2)\3)*4,"=")
  For j = 0 To l - ((l Mod 3)+1) Step 3
    t[k+0]=C[e0(S[j+0])]
    t[k+1]=C[e1(S[j+0],S[j+1])]
    t[k+2]=C[e2(S[j+1],S[j+2])]
    t[k+3]=C[e3(S[j+2])]:k+=4
  Next
  If (l mod 3) = 2 Then
    t[k+0]=C[e0(S[j+0])]
    t[k+1]=C[e1(S[j+0],S[j+1])]
    t[k+2]=C[e2(S[j+1],S[j+2])]
    t[k+3]=61
  ElseIf (l mod 3) = 1 Then
    t[k+0]=C[e0(S[j+0])]
    t[k+1]=C[e1(S[j+0],S[j+1])]
    t[k+2]=61
    t[k+3]=61
  End If
  return t
End Function

function Answer(byval fd as FDSOCKET) as string
  dim as string tmp
  NetReceiveString(fd,tmp)
  ? "<" & tmp
  return tmp
end function

sub ErrorEnd(byref hSocket as integer=-1, _
             byval ErrMsg  as string ="")
  if hSocket<>-1 then NetClose hSocket
  if ErrMsg<>"" then
    ? "error: " & ErrMsg & " !"
    beep:sleep
  end if
  end 1
end sub

'Define vars
Dim As FDSOCKET    hClient
Dim As WSADATA     wsData
Dim As SOCKADDR_in ServerAddr
Dim As HOSTENT Ptr lpResolver
Dim As String strDomain  , strServer        , _
              strUser    , strUserEncode    , _
              strPassword, strPasswordEncode, _
              strFrom    , strTo            , _
              strSubject , strBody

strDomain  ="anything"
strServer  ="smtp.xxx.yyy" ' smpte server
strUser    =""  ' login name
strPassword=""  ' login password
strFrom    ="" ' xxxx@yyy.zzz
strTo      ="" ' xxxx@yyy.zzz
strSubject ="Only an test don't read!"
strBody    ="The message."

strUserEncode    =Encode(strUser)
strPasswordEncode=Encode(strPassword)

'create socket
hClient=NetSocket(AF_INET,SOCK_STREAM)
If hClient<0 Then 
  ErrorEnd ,"NetSocket"
end if

'get the host
lpResolver=NetGetHostByName (strServer)
If lpResolver=0 Then 
  ErrorEnd hClient,"NetGetHostByName"
end if

With ServerAddr
  .sin_family = AF_INET
  .sin_port   = htons(25)  ' SMTP port
  .sin_addr   = *lpResolver->h_addr_ip_list[0] ' ip from server
End With

If NetConnect(hClient,@ServerAddr)<0 Then ErrorEnd hClient,"NetConnect"
if left(Answer(hClient),3)<>"220" then ErrorEnd hClient,"not 220"
NetSendString(hClient,"helo " & strServer & CRLF)
if left(Answer(hClient),3)<>"250" then  ErrorEnd hClient,"helo"
NetSendString(hClient,"AUTH LOGIN" & CRLF)
if left(Answer(hClient),3)<>"334" then  ErrorEnd hClient,"login"
NetSendString(hClient,strUserEncode & CRLF)
if left(Answer(hClient),3)<>"334" then  ErrorEnd hClient,"user"
NetSendString(hClient,strPasswordEncode & CRLF)
if left(Answer(hClient),3)<>"235" then  ErrorEnd hClient,"password"


NetSendString(hClient,"mail from: " & strFrom & CRLF)
if left(Answer(hClient),3)<>"250" then  ErrorEnd hClient,"MAIL FROM:"
NetSendString(hClient,"rcpt to: " & strTo & CRLF)
if left(Answer(hClient),3)<>"250" then  ErrorEnd hClient,"RCPT TO:"
NetSendString(hClient,"DATA" & CRLF)
if left(Answer(hClient),3)<>"354" then  ErrorEnd hClient,"DATA"
NetSendString(hClient,"Subject: " & strSubject & CRLF)
NetSendString(hClient,strBody & CRLF & CRLF & "." & CRLF)
if left(Answer(hClient),3)<>"250" then  ErrorEnd hClient,"body"

NetSendString(hClient,"QUIT" & CRLF)
if left(Answer(hClient),3)<>"221" then  ErrorEnd hClient,"quit"
? "mail sended"
NetClose hClient

sleep
end 0

