REM
REM  This file is part of the zBoy project
REM  Copyright (C) Mateusz Viste 2011
REM

SUB tableQsort(myarray() AS UINTEGER, BYREF LastEl AS UINTEGER)
    DIM AS INTEGER qstack(200)
    DIM AS INTEGER i, j, first, last, stackptr
    DIM AS UINTEGER temp

    first = Lbound(myarray)
    last  = LastEl 'ubound(myarray)
    DO
        DO
            temp = myarray((last + first)\2)
            i = first
            j = last
            DO  'reverse both < and > below to sort descending
                WHILE (myarray(i) > temp)
                    i += 1
                WEND
                WHILE (myarray(j) < temp)
                    j -= 1
                WEND
                IF (i > j) THEN
                    EXIT DO
                END IF
                IF (i < j) THEN
                    SWAP myarray(i), myarray(j)
                END IF
                i += 1
                j -= 1
            LOOP UNTIL (i > j)
            IF (i < last) THEN
                qstack(stackptr) = i
                qstack(stackptr + 1) = last
                stackptr += 2
            END IF
            last = j
        LOOP UNTIL (first >= last)
        IF stackptr = 0 THEN
            EXIT DO
        END IF
        stackptr -= 2
        first = qstack(stackptr)
        last = qstack(stackptr + 1)
    LOOP
END SUB
