REM
REM PrintMsg()
REM

SUB PrintMsg(BYREF txtorgmessage AS STRING, BYREF TransparentFlag AS UBYTE = 0)
  REM TransparentFlag = 1  -->  Do not clear the screen, and do not print background on chars
  REM TransparentFlag = 0  --> Clear the screen before doing anything
  DIM AS BYTE pixrow, pixcol, linenum
  DIM AS INTEGER x
  DIM AS STRING textstring, txtmessage = txtorgmessage
  IF (TransparentFlag = 0) THEN
    FOR pixcol = 0 TO 159
      FOR pixrow = 0 TO 143
        ScreenBuffer(pixcol, pixrow) = 0
      NEXT pixrow
    NEXT pixcol
  END IF
  DO
    textstring = WordWrap(txtmessage, 22)
    IF LEN(textstring) > 0 THEN
      FOR x = 0 TO (LEN(textstring) - 1)
        IF (textstring[x] >= 32) AND (textstring[x] <= 94) THEN
          FOR pixrow = 0 TO 7
            FOR pixcol = -1 TO 7
              IF BIT(FontData(textstring[x], pixrow), pixcol) <> 0 THEN
                  ScreenBuffer(pixcol + (x * 7) + 3, pixrow + (linenum * 8)) = 3
                ELSE ' check if needed to display text shadow.
                  IF (pixrow > 0) THEN
                    IF (BIT(FontData(textstring[x], pixrow - 1), pixcol) <> 0) THEN
                      ScreenBuffer(pixcol + (x * 7) + 3, pixrow + (linenum * 8)) = 0
                    END IF
                  END IF
                  IF (pixcol > 0) THEN
                    IF (BIT(FontData(textstring[x], pixrow), pixcol - 1) <> 0) THEN
                      ScreenBuffer(pixcol + (x * 7) + 3, pixrow + (linenum * 8)) = 0
                    END IF
                  END IF
                  IF (pixcol < 7) THEN
                    IF (BIT(FontData(textstring[x], pixrow), pixcol + 1) <> 0) THEN
                      ScreenBuffer(pixcol + (x * 7) + 3, pixrow + (linenum * 8)) = 0
                    END IF
                  END IF
                  IF (pixrow < 7) THEN
                    IF (BIT(FontData(textstring[x], pixrow + 1), pixcol) <> 0) THEN
                      ScreenBuffer(pixcol + (x * 7) + 3, pixrow + (linenum * 8)) = 0
                    END IF
                  END IF
              END IF
            NEXT pixcol
          NEXT pixrow
        END IF
      NEXT x
    END IF
    linenum += 1
  LOOP UNTIL (LEN(txtmessage) = 0) OR (linenum = 19)
  RefreshScreen()
END SUB
